package sorting;

import java.util.*;

public class SortingDataTest {

	final public static int LENGTH = 4;
	
	static int max = 0;
	
	public static int count=0;
	
	
	static class MyInteger implements Comparable<MyInteger> {
		public int value;
		public MyInteger(int x){
			value=x;
		}
		public int compareTo(MyInteger x){
			count++;
			if (value<x.value)return -1;
			else if (value>x.value)return 1;
			else return 0;
		}
	}
	
	//mergeSort
	private static void mergeSort(MyInteger[] a, MyInteger[] tmp, int left, int right){
		if(left<right){
			int center = (left+right)/2;
			mergeSort(a,tmp,left,center);
			mergeSort(a,tmp,center+1,right);
			merge(a,tmp,left,center+1,right);
		}
	}
	public static void mergeSort(MyInteger[] a){
		MyInteger[] tmp=new MyInteger[a.length];
		mergeSort(a,tmp,0,a.length-1);
	}
	private static void merge(MyInteger[] a, MyInteger[] tmp, int leftPos, int rightPos, int rightEnd){
		int leftEnd=rightPos-1;
		int tmpPos=leftPos;
		int numElements=rightEnd-leftPos+1;
		
		while(leftPos<=leftEnd && rightPos<=rightEnd){
			if(a[leftPos].compareTo(a[rightPos])<=0)
				tmp[tmpPos++]=a[leftPos++];
			else
				tmp[tmpPos++]=a[rightPos++];
		}
		while(leftPos<=leftEnd) tmp[tmpPos++]=a[leftPos++];
		while(rightPos<=rightEnd) tmp[tmpPos++]=a[rightPos++];	
		
		for(int i=0;i<numElements;i++,rightEnd--)
			   a[rightEnd]=tmp[rightEnd];
	}

	
	public static void swapReferences( MyInteger [ ] a, int index1, int index2 )
	{
		//System.out.printf("sr: %d %d\n",index1,index2);
		MyInteger tmp = a[ index1 ];
		a[ index1 ] = a[ index2 ];
		a[ index2 ] = tmp;
	}

	public static void quickSort( MyInteger [ ] a )
	{
		quickSort( a, 0, a.length - 1 );
	}

	private static void quickSort( MyInteger [ ] a, int left, int right )
	{

		// System.out.printf("qs: %d %d\n",left,right);
		
		if (left >= right) return;

		int half = (left + right) / 2;
		MyInteger pivot = a[half];
		// System.out.println("swap pivot");
		swapReferences(a,half,right);

		int i = left-1, j = right;
		for( ; ; )
		{
			while( i<right && a[ ++i ].compareTo( pivot ) < 0 ) { }
			while( j>left && a[ --j ].compareTo( pivot ) > 0) { }
			if( i < j )
				swapReferences(a,i,j);
			else
				break;
		}

		// System.out.println("swap pivot back");
		swapReferences(a,right,i);

		quickSort( a, left, i - 1 );    // Sort small elements
		quickSort( a, i + 1, right );   // Sort large elements
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		count=0;
		MyInteger[] a=new MyInteger[SortingData.mergeSortBest.length];
		for(int i=0;i<SortingData.mergeSortBest.length;i++)
			a[i]=new MyInteger(SortingData.mergeSortBest[i].intValue());
		mergeSort(a);
		System.out.println(count);
		for(MyInteger x: a)
			System.out.print(x.value+" ");
		System.out.println();
		
		
		count=0;
		a=new MyInteger[SortingData.mergeSortWorst.length];
		for(int i=0;i<SortingData.mergeSortWorst.length;i++)
			a[i]=new MyInteger(SortingData.mergeSortWorst[i].intValue());
		mergeSort(a);
		System.out.println(count);
		for(MyInteger x: a)
			System.out.print(x.value+" ");
		System.out.println();
		
		
		count=0;
		a=new MyInteger[SortingData.quickSortBest.length];
		for(int i=0;i<SortingData.quickSortBest.length;i++)
			a[i]=new MyInteger(SortingData.quickSortBest[i].intValue());
		quickSort(a);
		System.out.println(count);
		for(MyInteger x: a)
			System.out.print(x.value+" ");
		System.out.println();
		
		count=0;
		a=new MyInteger[SortingData.quickSortWorst.length];
		for(int i=0;i<SortingData.quickSortWorst.length;i++)
			a[i]=new MyInteger(SortingData.quickSortWorst[i].intValue());
		quickSort(a);
		System.out.println(count);
		for(MyInteger x: a)
			System.out.print(x.value+" ");
		System.out.println();
	}

}
